#include <iostream>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <queue>
#include <algorithm>

using namespace std;

#define INF 1 << 31 - 1

int t, n;
int cnt;
int lastshow[40010];
int d[40010];
typedef pair<int, int> pii;
priority_queue<pii, vector<pii>, greater<pii> > q;

struct edge{
    int to;
    int wei;
    int next;
}e[40010];

void insert(int a, int b, int c){
    cnt ++;
    e[cnt].to = b;
    e[cnt].next = lastshow[a];
    e[cnt].wei = c;
    lastshow[a] = cnt;
}

bool done[40010];
void dijkstra(){
    memset(done, 0, sizeof(done));
    q.push(make_pair(d[1], 1));
    while(!q.empty()){
        pii u = q.top();
        q.pop();
        int x = u.second;
        if(done[x])
            continue;
        done[x] = true;
        for(int i = lastshow[x]; i != -1; i = e[i].next){
            if(d[e[i].to] > d[x] + e[i].wei){
                d[e[i].to] = d[x] + e[i].wei;
                q.push(make_pair(d[e[i].to], e[i].to));
            }
        }
    }
}

int main(){
    int i, j, k, m, ww, x, y;
    int z;
    int cnt;
    while(cin >> t >> n){
        cnt = 0;
        memset(lastshow, -1, sizeof(lastshow));
        for(i = 1; i <= n; i ++)        //i
            d[i] = (i == 1 ? 0 : INF);
        for(i = 0; i < t; i ++){        //
            int a, b, c;
            scanf("%d %d %d", &a, &b, &c);
            insert(a, b, c);
            insert(b, a, c);
        }
        dijkstra();
        cout << d[n] << endl;
    }
    return 0;
}